// Copyright 2004 Laurent GUEGUEN

// This file is part of Sarment.

// Sarment is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// Sarment is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Sarment; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#if !defined _VALEUR_H_
#define _VALEUR_H_

class Cvaleur  
{
  double _val;
public:
  inline Cvaleur();
  inline Cvaleur(const double);
  inline Cvaleur(const Cvaleur&);
  inline ~Cvaleur() {};

  inline double val() const;
  inline double operator+(const Cvaleur&) const;
  inline double operator*(const Cvaleur&) const;

  // modif
  inline void g_val(const double);
  inline void g_val(const Cvaleur&);
  inline void operator=(const double);
  inline void operator=(const Cvaleur&);
  inline void operator+=(const Cvaleur&);
  inline void operator+=(const double);
  inline void operator-=(const Cvaleur&);
  inline void operator-=(const double);
  inline void operator*=(const double);
  inline void operator++();
  inline void operator++(int);
  inline void operator--();
  inline void operator--(int);

  inline void operator/=(const double);

  // tests 
  inline bool operator==(const Cvaleur&) const;
  inline bool operator!=(const Cvaleur&) const;
  inline bool operator<(const Cvaleur&) const;
  inline bool operator>(const Cvaleur&) const;
  inline bool operator<(const double&) const;
  inline bool operator>(const double&) const;
  inline bool operator<=(const Cvaleur&) const;
  inline bool operator>=(const Cvaleur&) const;
  inline bool operator<=(const double&) const;
  inline bool operator>=(const double&) const;

};

#include "valeur.inl"

#endif 
