// Copyright 2004 Laurent GUEGUEN

// This file is part of Sarment.

// Sarment is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// Sarment is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Sarment; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Cvaleur::Cvaleur() : _val(0)
{
}

Cvaleur::Cvaleur(const double x) : _val(x)
{
}

Cvaleur::Cvaleur(const Cvaleur& x) : _val(x._val)
{
}

double Cvaleur::val() const
{
	return(_val);
}


void Cvaleur::g_val(const double x)
{
	_val=x;
}

void Cvaleur::operator++()
{
  _val++;
}

void Cvaleur::operator++(int)
{
  _val++;
}

void Cvaleur::operator--()
{
  _val--;
}

void Cvaleur::operator--(int)
{
  _val--;
}

void Cvaleur::operator+=(const Cvaleur& x)
{
	_val+=x._val;
}

void Cvaleur::operator-=(const Cvaleur& x)
{
	_val-=x._val;
}

void Cvaleur::operator=(const Cvaleur& x)
{
	_val=x._val;
}

void Cvaleur::g_val(const Cvaleur& x)
{
	_val=x._val;
}

void Cvaleur::operator+=(const double x)
{
	_val+=x;
}

void Cvaleur::operator-=(const double x)
{
	_val-=x;
}

void Cvaleur::operator/=(const double x)
{
	_val/=x;
}

void Cvaleur::operator*=(const double x)
{
	_val*=x;
}

void Cvaleur::operator=(const double x)
{
	_val=x;
}

double Cvaleur::operator+(const Cvaleur& x) const
{
	return(_val+x._val);
}

double Cvaleur::operator*(const Cvaleur& x) const
{
	return(_val*x._val);
}

bool Cvaleur::operator==(const Cvaleur& x) const
{
	return (_val==x._val);
}

bool Cvaleur::operator!=(const Cvaleur& x) const
{
	return (_val!=x._val);
}

bool Cvaleur::operator<(const Cvaleur& x) const
{
	return (_val<x._val);
}

bool Cvaleur::operator>(const Cvaleur& x) const
{
	return (_val>x._val);
}

bool Cvaleur::operator<(const double& x) const
{
	return (_val<x);
}

bool Cvaleur::operator>(const double& x) const
{
	return (_val>x);
}

bool Cvaleur::operator<=(const Cvaleur& x) const
{
	return (_val<=x._val);
}

bool Cvaleur::operator>=(const Cvaleur& x) const
{
	return (_val>=x._val);
}

bool Cvaleur::operator<=(const double& x) const
{
	return (_val<=x);
}

bool Cvaleur::operator>=(const double& x) const
{
	return (_val>=x);
}
